#include "xmltk.h"

// *** IUnknown methods ***
bool CTSAXContentHandler::QueryInterface(RCLIID riid, void **ppvObj)
{
    if (IsEqualCLIID(riid, &IID_IUnknownCL) ||
        IsEqualCLIID(riid, &IID_ITSAXContentHandler)){
        *ppvObj = static_cast<ITSAXContentHandler*>(this);
    }
    else {
        *ppvObj = NULL;
        return false;
    }
    AddRef();
    return true;
}

ULONG CTSAXContentHandler::AddRef()
{
    return ++m_cRef;
}

ULONG CTSAXContentHandler::Release()
{
    if (--m_cRef > 0)
    {
        return m_cRef;
    }
    delete this;
    return 0;
}